Index: /branches/UKMO/dev_r5518_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_write.F90
===================================================================
--- /branches/UKMO/dev_r5518_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_write.F90	(revision 9305)
+++ /branches/UKMO/dev_r5518_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_write.F90	(revision 9306)
@@ -84,4 +84,7 @@
       CHARACTER(LEN=40) :: clfname
       CHARACTER(LEN=10) :: clfiletype
+      CHARACTER(LEN=ilenlong) :: cllongname  ! Long name of variable
+      CHARACTER(LEN=ilenunit) :: clunits     ! Units of variable
+      CHARACTER(LEN=ilengrid) :: clgrid      ! Grid of variable
       INTEGER :: ilevel
       INTEGER :: jvar
@@ -111,5 +114,5 @@
       ! Find maximum level
       ilevel = 0
-      DO jvar = 1, 2
+      DO jvar = 1, profdata%nvar
          ilevel = MAX( ilevel, MAXVAL( profdata%var(jvar)%nvlidx(:) ) )
       END DO
@@ -175,5 +178,90 @@
          END DO
 
+      CASE('PLCHLTOT')
+
+         clfiletype = 'plchltotfb'
+         cllongname = 'log10(chlorophyll concentration)'
+         clunits    = 'log10(mg/m3)'
+         clgrid     = 'T'
+
+      CASE('PCHLTOT')
+
+         clfiletype = 'pchltotfb'
+         cllongname = 'chlorophyll concentration'
+         clunits    = 'mg/m3'
+         clgrid     = 'T'
+
+      CASE('PNO3')
+
+         clfiletype = 'pno3fb'
+         cllongname = 'nitrate'
+         clunits    = 'mmol/m3'
+         clgrid     = 'T'
+
+      CASE('PSI4')
+
+         clfiletype = 'psi4fb'
+         cllongname = 'silicate'
+         clunits    = 'mmol/m3'
+         clgrid     = 'T'
+
+      CASE('PPO4')
+
+         clfiletype = 'ppo4fb'
+         cllongname = 'phosphate'
+         clunits    = 'mmol/m3'
+         clgrid     = 'T'
+
+      CASE('PDIC')
+
+         clfiletype = 'pdicfb'
+         cllongname = 'dissolved inorganic carbon'
+         clunits    = 'mmol/m3'
+         clgrid     = 'T'
+
+      CASE('PALK')
+
+         clfiletype = 'palkfb'
+         cllongname = 'alkalinity'
+         clunits    = 'meq/m3'
+         clgrid     = 'T'
+
+      CASE('PPH')
+
+         clfiletype = 'pphfb'
+         cllongname = 'pH'
+         clunits    = '-'
+         clgrid     = 'T'
+
+      CASE('PO2')
+
+         clfiletype = 'po2fb'
+         cllongname = 'dissolved oxygen'
+         clunits    = 'mmol/m3'
+         clgrid     = 'T'
+
       END SELECT
+      
+      IF ( ( TRIM(profdata%cvars(1)) /= 'POTM' ) .AND. &
+         & ( TRIM(profdata%cvars(1)) /= 'UVEL' ) ) THEN
+         CALL alloc_obfbdata( fbdata, 1, profdata%nprof, ilevel, &
+            &                 1 + iadd, iext, .TRUE. )
+         fbdata%cname(1)      = profdata%cvars(1)
+         fbdata%coblong(1)    = cllongname
+         fbdata%cobunit(1)    = clunits
+         fbdata%caddlong(1,1) = 'Model interpolated ' // TRIM(cllongname)
+         fbdata%caddunit(1,1) = clunits
+         fbdata%cgrid(:)      = clgrid
+         DO je = 1, iext
+            fbdata%cextname(je) = pext%cdname(je)
+            fbdata%cextlong(je) = pext%cdlong(je,1)
+            fbdata%cextunit(je) = pext%cdunit(je,1)
+         END DO
+         DO ja = 1, iadd
+            fbdata%caddname(1+ja) = padd%cdname(ja)
+            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
+            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
+         END DO
+      ENDIF
 
       fbdata%caddname(1)   = 'Hx'
@@ -228,5 +316,5 @@
             &           krefdate = 19500101 )
          ! Reform the profiles arrays for output
-         DO jvar = 1, 2
+         DO jvar = 1, profdata%nvar
             DO jk = profdata%npvsta(jo,jvar), profdata%npvend(jo,jvar)
                ik = profdata%var(jvar)%nvlidx(jk)
@@ -322,4 +410,7 @@
       CHARACTER(LEN=10) :: clfiletype
       CHARACTER(LEN=12), PARAMETER :: cpname = 'obs_wri_surf'
+      CHARACTER(LEN=ilenlong) :: cllongname  ! Long name of variable
+      CHARACTER(LEN=ilenunit) :: clunits     ! Units of variable
+      CHARACTER(LEN=ilengrid) :: clgrid      ! Grid of variable
       INTEGER :: jo
       INTEGER :: ja
@@ -344,4 +435,7 @@
       SELECT CASE ( TRIM(surfdata%cvars(1)) )
       CASE('SLA')
+
+         ! SLA needs special treatment because of MDT, so is all done here
+         ! Other variables are done more generically
 
          CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
@@ -374,11 +468,138 @@
       CASE('SST')
 
+         clfiletype = 'sstfb'
+         cllongname = 'Sea surface temperature'
+         clunits    = 'Degree centigrade'
+         clgrid     = 'T'
+
+      CASE('ICECONC')
+
+         clfiletype = 'sicfb'
+         cllongname = 'Sea ice'
+         clunits    = 'Fraction'
+         clgrid     = 'T'
+
+      CASE('SSS')
+
+         clfiletype = 'sssfb'
+         cllongname = 'Sea surface salinity'
+         clunits    = 'psu'
+         clgrid     = 'T'
+
+      CASE('SLCHLTOT','LOGCHL','LogChl','logchl')
+
+         clfiletype = 'slchltotfb'
+         cllongname = 'Surface total log10(chlorophyll)'
+         clunits    = 'log10(mg/m3)'
+         clgrid     = 'T'
+
+      CASE('SLCHLDIA')
+
+         clfiletype = 'slchldiafb'
+         cllongname = 'Surface diatom log10(chlorophyll)'
+         clunits    = 'log10(mg/m3)'
+         clgrid     = 'T'
+
+      CASE('SLCHLNON')
+
+         clfiletype = 'slchlnonfb'
+         cllongname = 'Surface non-diatom log10(chlorophyll)'
+         clunits    = 'log10(mg/m3)'
+         clgrid     = 'T'
+
+      CASE('SLCHLDIN')
+
+         clfiletype = 'slchldinfb'
+         cllongname = 'Surface dinoflagellate log10(chlorophyll)'
+         clunits    = 'log10(mg/m3)'
+         clgrid     = 'T'
+
+      CASE('SLCHLMIC')
+
+         clfiletype = 'slchlmicfb'
+         cllongname = 'Surface microphytoplankton log10(chlorophyll)'
+         clunits    = 'log10(mg/m3)'
+         clgrid     = 'T'
+
+      CASE('SLCHLNAN')
+
+         clfiletype = 'slchlnanfb'
+         cllongname = 'Surface nanophytoplankton log10(chlorophyll)'
+         clunits    = 'log10(mg/m3)'
+         clgrid     = 'T'
+
+      CASE('SLCHLPIC')
+
+         clfiletype = 'slchlpicfb'
+         cllongname = 'Surface picophytoplankton log10(chlorophyll)'
+         clunits    = 'log10(mg/m3)'
+         clgrid     = 'T'
+
+      CASE('SCHLTOT')
+
+         clfiletype = 'schltotfb'
+         cllongname = 'Surface total chlorophyll'
+         clunits    = 'mg/m3'
+         clgrid     = 'T'
+
+      CASE('SLPHYTOT')
+
+         clfiletype = 'slphytotfb'
+         cllongname = 'Surface total log10(phytoplankton carbon)'
+         clunits    = 'log10(mmolC/m3)'
+         clgrid     = 'T'
+
+      CASE('SLPHYDIA')
+
+         clfiletype = 'slphydiafb'
+         cllongname = 'Surface diatom log10(phytoplankton carbon)'
+         clunits    = 'log10(mmolC/m3)'
+         clgrid     = 'T'
+
+      CASE('SLPHYNON')
+
+         clfiletype = 'slphynonfb'
+         cllongname = 'Surface non-diatom log10(phytoplankton carbon)'
+         clunits    = 'log10(mmolC/m3)'
+         clgrid     = 'T'
+
+      CASE('SSPM')
+
+         clfiletype = 'sspmfb'
+         cllongname = 'Surface suspended particulate matter'
+         clunits    = 'g/m3'
+         clgrid     = 'T'
+
+      CASE('SFCO2','FCO2','fCO2','fco2')
+
+         clfiletype = 'sfco2fb'
+         cllongname = 'Surface fugacity of carbon dioxide'
+         clunits    = 'uatm'
+         clgrid     = 'T'
+
+      CASE('SPCO2')
+
+         clfiletype = 'spco2fb'
+         cllongname = 'Surface partial pressure of carbon dioxide'
+         clunits    = 'uatm'
+         clgrid     = 'T'
+
+      CASE DEFAULT
+
+         CALL ctl_stop( 'Unknown observation type '//TRIM(surfdata%cvars(1))//' in obs_wri_surf' )
+
+      END SELECT
+
+      ! SLA needs special treatment because of MDT, so is done above
+      ! Remaining variables treated more generically
+
+      IF ( TRIM(surfdata%cvars(1)) /= 'SLA' ) THEN
+      
          CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
             &                 1 + iadd, iext, .TRUE. )
 
-         clfiletype = 'sstfb'
          fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'Sea surface temperature'
-         fbdata%cobunit(1)    = 'Degree centigrade'
+         fbdata%coblong(1)    = cllongname
+         fbdata%cobunit(1)    = clunits
          DO je = 1, iext
             fbdata%cextname(je) = pext%cdname(je)
@@ -386,7 +607,11 @@
             fbdata%cextunit(je) = pext%cdunit(je,1)
          END DO
-         fbdata%caddlong(1,1) = 'Model interpolated SST'
-         fbdata%caddunit(1,1) = 'Degree centigrade'
-         fbdata%cgrid(1)      = 'T'
+         IF ( TRIM(surfdata%cvars(1)) == 'ICECONC' ) THEN
+            fbdata%caddlong(1,1) = 'Model interpolated ICE'
+         ELSE
+            fbdata%caddlong(1,1) = 'Model interpolated ' // TRIM(surfdata%cvars(1))
+         ENDIF
+         fbdata%caddunit(1,1) = clunits
+         fbdata%cgrid(1)      = clgrid
          DO ja = 1, iadd
             fbdata%caddname(1+ja) = padd%cdname(ja)
@@ -395,148 +620,6 @@
          END DO
 
-      CASE('ICECONC')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 1 + iadd, iext, .TRUE. )
-
-         clfiletype = 'sicfb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'Sea ice'
-         fbdata%cobunit(1)    = 'Fraction'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated ICE'
-         fbdata%caddunit(1,1) = 'Fraction'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE('SSS')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 1 + iadd, iext, .TRUE. )
-
-         clfiletype = 'sssfb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'Sea surface salinity'
-         fbdata%cobunit(1)    = 'psu'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated SSS'
-         fbdata%caddunit(1,1) = 'psu'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE('LOGCHL','LogChl','logchl')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 1 + iadd, iext, .TRUE. )
-
-         clfiletype = 'logchlfb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'logchl concentration'
-         fbdata%cobunit(1)    = 'mg/m3'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated LOGCHL'
-         fbdata%caddunit(1,1) = 'mg/m3'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE('SPM','Spm','spm')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 1 + iadd, iext, .TRUE. )
-
-         clfiletype = 'spmfb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'spm'
-         fbdata%cobunit(1)    = 'g/m3'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated spm'
-         fbdata%caddunit(1,1) = 'g/m3'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE('FCO2','fCO2','fco2')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 1 + iadd, iext, .TRUE. )
-
-         clfiletype = 'fco2fb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'fco2'
-         fbdata%cobunit(1)    = 'uatm'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated fco2'
-         fbdata%caddunit(1,1) = 'uatm'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE('PCO2','pCO2','pco2')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 1 + iadd, iext, .TRUE. )
-
-         clfiletype = 'pco2fb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'pco2'
-         fbdata%cobunit(1)    = 'uatm'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated pco2'
-         fbdata%caddunit(1,1) = 'uatm'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE DEFAULT
-
-         CALL ctl_stop( 'Unknown observation type '//TRIM(surfdata%cvars(1))//' in obs_wri_surf' )
-
-      END SELECT
-
+      ENDIF
+      
       fbdata%caddname(1)   = 'Hx'
 
